|==========================
|Tokens d'Excution de base
|==========================
		.include  "os.h"
		
		.include  "Defines.h"
		.include  "Tbl_Errors.h"
		.include  "TokensExec.h"
		.include  "GFATEM.h"

                .xdef     ExecToken_None
                .xdef     ExecToken_Jump
                .xdef     ExecToken_If
                .xdef     ExecToken_IfJump
                .xdef     ExecToken_Clear
                .xdef     ExecToken_EOFLine
                .xdef     ExecToken_EndTag
                .xdef     ExecToken_PointVirgule
                .xdef     ExecToken_Apost
                
                .xdef     ExecToken_Number_Float
                .xdef     ExecToken_Number_Int
                .xdef     ExecToken_String
                
                .xdef     ExecToken_Var_Float
		.xdef     ExecToken_Var_String
		.xdef     ExecToken_Var_Int
		.xdef     ExecToken_Var_Bool
		
		.xdef     ExecToken_Var_TFloat
		.xdef     ExecToken_Var_TString
		.xdef     ExecToken_Var_TInt
		.xdef     ExecToken_Var_TBool
			
		.xdef     ExecToken_Math_Add
		.xdef     ExecToken_Math_Sub
		.xdef     ExecToken_Math_Mul
		.xdef     ExecToken_Math_Div
		.xdef     ExecToken_Math_Puiss
		
		.xdef     ExecToken_Compare_Superior
		.xdef     ExecToken_Compare_Inferior
		.xdef     ExecToken_Egal
		.xdef     ExecToken_Supegal
		.xdef     ExecToken_Infegal
		.xdef     ExecToken_Diff
		
		.xdef     ExecToken_Affec
		
		.xdef     ExecToken_Logic_Not
		.xdef     ExecToken_Logic_And
		.xdef     ExecToken_Logic_Or
		.xdef     ExecToken_Logic_Xor
		.xdef     ExecToken_Logic_Imp
		.xdef     ExecToken_Logic_Eqv
		.xdef     ExecToken_Math_Mod
		.xdef     ExecToken_Math_Divint
		
		.xdef     ExecToken_Negatif
                                   
_ExecToken_exit:
		rts

|=================|
|Tokens de gestion|
|=================|                                 
ExecToken_None:
		rts
		
ExecToken_Jump:
		movea.l   TokensFile_DataPtr(%PC),%a0		|Adresse de la donnes en cours
		moveq.l   #0,%d0				|Efface d0
		move.w    (%a0),%d0				|Rcupre valeur de saut
		move.l    TokensFile_Data(%PC),%d1		|Adresse de dbut des donnes
		add.l     %d0,%d1				|Ce place  l'adresse du saut
		move.l    %d1,TokensFile_DataPtr    		|Modifie pointeur
		rts
		
ExecToken_If:
		|Conversion en boolen
		movea.l   %a5,%a2				|Number1
		move.b    1(%a2),%d0				|Type source
		move.b    #TYPE_BOOL,%d1			|Type destination
		jbsr      TokensExec_ConvertType		|Conversion	
		tst.w     %d7					|Echec opration?
		jbeq	  _ExecToken_exit
		
		|Gestion du saut
		movea.l   4(%a2),%a2				|Boolen
		tst.b     (%a2)					|Si 0 jump sinon +2
		jbeq      ExecToken_Jump
		addq.l    #2,TokensFile_DataPtr			|Ajoute 2 au pointeur de donnes		
		rts
	
ExecToken_IfJump:
		|Conversion en boolen
		movea.l   %a5,%a2				|Number1
		move.b    1(%a2),%d0				|Type source
		move.b    #TYPE_BOOL,%d1			|Type destination
		jbsr      TokensExec_ConvertType		|Conversion
		tst.w     %d7					|Echec opration?
		jbeq	  _ExecToken_exit
		
		|Gestion du saut
		movea.l   4(%a2),%a2				|Boolen
		tst.b     (%a2)					|Si -1 jump sinon +2
		jbne      ExecToken_Jump
		addq.l    #2,TokensFile_DataPtr			|Ajoute 2 au pointeur de donnes		
		rts
		
ExecToken_Clear:
		movea.l   ptrEnd_ES(%PC),%a5			|Efface pile ES
		move.l    ptrData_DT(%PC),DTO			|Efface tampon DT
		rts
		
ExecToken_EOFLine:
		movea.l   TokensFile_DataPtr(%PC),%a0		|Adresse de la donnes en cours
		move.w    (%a0),error_line			|Rcupre numro de ligne
		addq.l    #2,TokensFile_DataPtr			|Ajoute 2 pour token suivant
		movea.l   ptrEnd_ES(%PC),%a5			|Efface pile ES
		move.l    ptrData_DT(%PC),DTO			|Efface tampon DT
		rts
		
ExecToken_EndTag:
		lea.l     -4-2-1(%a5),%a5			|Saute adresse,2 octets d'infos supplmentaires et type
		move.b    #OPRD_ENDTAG,-(%a5)			|Empile oprande
		rts
		
ExecToken_PointVirgule:
		lea.l     -4-2-1(%a5),%a5			|Saute adresse,2 octets d'infos supplmentaires et type
		move.b    #OPRD_POINT_VIRGULE,-(%a5)		|Empile oprande
		rts
		
ExecToken_Apost:
		lea.l     -4-2-1(%a5),%a5			|Saute adresse,2 octets d'infos supplmentaires et type
		move.b    #OPRD_APOST,-(%a5)			|Empile oprande
		rts
		

|=======================================|
|Tokens de gestion des donnes statiques|
|=======================================|
ExecToken_Number_Float:
		move.l    TokensFile_DataPtr(%PC),%d0		|Adresse de la donnes en cours
		move.l    %d0,-(%a5)				|Empile adresse dans ES
		lea.l     -2(%a5),%a5				|Saute les 2 octets d'infos supplmentaires
		move.b    #TYPE_FLOAT,-(%a5)			|Empile type de donnes
		move.b    #OPRD_NUMBER,-(%a5)			|Empile Oprande
		addi.l    #10,%d0				|Saute le nombre (prpare token suivant)
		move.l    %d0,TokensFile_DataPtr		|Avance pointeur
		rts
		
ExecToken_Number_Int:
		move.l   TokensFile_DataPtr(%PC),%d0		|Adresse de la donnes en cours
		move.l   %d0,-(%a5)				|Empile adresse dans ES
		lea.l    -2(%a5),%a5				|Saute les 2 octets d'infos supplmentaires
		move.b   #TYPE_INTEGER,-(%a5)			|Empile type de donnes
		move.b   #OPRD_NUMBER,-(%a5)			|Empile oprande
		addq.l   #4,%d0					|Saute le nombre (prpare token suivant)
		move.l   %d0,TokensFile_DataPtr			|Avance pointeur
		rts
		
ExecToken_String:
		rts


|===============================|
|Tokens de gestion des variables|
|===============================|		
ExecToken_Var_Float:
		movea.l  TokensFile_DataPtr(%PC),%a0		|Prpare lecture numro de la variable
		move.b   (%a0),%d0				|Lecture numro variable
		and.w    #0xFF,%d0				|Rcupre seulement les 8 bits LSB
		moveq.l  #0,%d1					|Efface d1	
		move.b   %d0,%d1				|Sauvegarde %d0 dans %d1
		lsl.w    #3,%d1					|Multiplie par 2^3=8 %d1
		add.w    %d0,%d0				|Multiplie par 2 %d0
		add.w    %d0,%d1				|Finale multiplication de 10
		move.l   VAR_FLOAT(%PC),%d0			|Adresse dbut variables flottants dans %d0
		add.l    %d1,%d0				|Zone de la variable n voulue
		move.l   %d0,-(%a5)				|Charge adresse dans la pile ES
		lea.l    -2(%a5),%a5				|Saute les 2 octets d'infos supplmentaires
		move.b   #TYPE_FLOAT,-(%a5)			|Empile type de donnes
		move.b   #OPRD_VAR,-(%a5)			|Empile oprande
		addq.l   #1,TokensFile_DataPtr			|Token suivant
		rts

ExecToken_Var_String:
		rts
		
ExecToken_Var_Int:
		movea.l  TokensFile_DataPtr(%PC),%a0		|Prpare lecture numro de la variable
		moveq.l  #0,%d1					|Efface d1
		move.b   (%a0),%d1				|Lecture numro variable
		lsl.w    #2,%d1					|Multiplication de 2^2=4
		move.l   VAR_INTEGER(%PC),%d0			|Adresse de dbut variables de type entier
		add.l    %d1,%d0				|Zone de la variable n voulue
		move.l   %d0,-(%a5)				|Charge adresse dans la pile ES
		lea.l    -2(%a5),%a5				|Saute les 2 octets d'infos supplmentaires
		move.b   #TYPE_INTEGER,-(%a5)			|Empile type de donnes
		move.b   #OPRD_VAR,-(%a5)			|Empile oprande
		addq.l   #1,TokensFile_DataPtr			|Token suivant
		rts
		
ExecToken_Var_Bool:
		movea.l  TokensFile_DataPtr(%PC),%a0		|Prapre lecture numro de la variable
		moveq.l  #0,%d1					|Efface d1
		move.b   (%a0),%d1				|Lecture numro variable
		move.l   VAR_BOOL(%PC),%d0			|Adresse de dbut variables de type entier
		add.l    %d1,%d0				|Zone de la variable n voulue
		move.l   %d0,-(%a5)				|Charge adresse dans la pile ES
		lea.l    -2(%a5),%a5				|Saute les 2 octets d'infos supplmentaires
		move.b   #TYPE_BOOL,-(%a5)			|Empile type de donnes
		move.b   #OPRD_VAR,-(%a5)			|Empile oprande
		addq.l   #1,TokensFile_DataPtr			|Token suivant
		rts


|==============================|
|Tokens de gestion des tableaux|
|==============================|
ExecToken_Var_TFloat:
		rts
		
ExecToken_Var_TString:
		rts
		
ExecToken_Var_TInt:
		rts
		
ExecToken_Var_TBool:
		rts
	
	
|=========================================|
|Tokens d'oprations mathmatiques simples|
|=========================================|
_ExecToken_Math_Add_integer:
		move.l    (%a1),%d1				|Number 1
		move.l    (%a0),%d0				|Number 2
		add.l     %d1,%d0
		jbra	  TokensExec_AddResult2_Integer
		
_ExecToken_Math_Add_float:
		|Empile number 1
		move.w    8(%a1),-(%SP)				|Empile fin flottant
		move.l    4(%a1),-(%SP)				|Empile milieu flottant
		move.l    (%a1),-(%SP)				|Empile dbut flottant
		|Empile number 2
		move.w    8(%a0),-(%SP)				|Empile fin flottant
		move.l    4(%a0),-(%SP)				|Empile milieu flottant
		move.l    (%a0),-(%SP)				|Empile dbut flottant
		move.w    #fadd*4,-(%sp)			|Wrapper
		jbsr      __BC
		lea.l     22(%SP),%SP
		jbra      TokensExec_AddResult2_Float
		
ExecToken_Math_Add:
		TokensExec_MathType TRUE, TRUE, FALSE, TRUE, #TYPE_INTEGER
		tst.w     %d7
		jbeq      _ExecToken_exit
		
		move.b    1(%a5),%d0				|Type number 1
		movea.l   4(%a5),%a1				|Number 1
		movea.l   12(%a5),%a0				|Number 2
		
		cmpi.b    #TYPE_INTEGER,%d0			|Addition entre entiers
		jbeq      _ExecToken_Math_Add_integer
		cmpi.b    #TYPE_FLOAT,%d0			|Addition entre flottants
		jbeq      _ExecToken_Math_Add_float
		
		|Bug avec A=pi+A!
		
		
		|Concantation de chanes de caractres
		rts
		
ExecToken_Math_Sub:
		rts
		
ExecToken_Math_Mul:
		rts
		
ExecToken_Math_Div:
		rts
		
ExecToken_Math_Puiss:
		rts
	
		
|======================|
|Tokens de comparaisons|
|======================|
ExecToken_Compare_Superior:
		rts
		
ExecToken_Compare_Inferior:
		rts
		
ExecToken_Egal:
		rts
		
ExecToken_Supegal:
		rts
		
ExecToken_Infegal:
		rts
		
ExecToken_Diff:
		rts


|===================|
|Token d'affectation|
|===================|
_ExecToken_Affec_integer:
		move.l    (%a0),(%a1)				|Ecrit entier
		lea.l     16(%a5),%a5				|Dpile ES de 2 items
		rts

_ExecToken_Affec_float:
		move.l    (%a0)+,(%a1)+				|Ecrit flottant
		move.l    (%a0)+,(%a1)+
		move.w    (%a0),(%a1)
		lea.l     16(%a5),%a5				|Dpile ES de 2 items
		rts
		
_ExecToken_Affec_bool:
		move.b    (%a0),(%a1)				|Ecrit boolen
		lea.l     16(%a5),%a5				|Dpile ES de 2 items
		rts
		
_ExecToken_Affec_next:
		move.b    1(%a5),%d0				|Type number 1
		move.b    9(%a5),%d1				|Type number 2
		movea.l   %a5,%a2				|ptr number 1
		jbsr      TokensExec_ConvertType
		tst.w     %d7
		jbeq      _ExecToken_exit
		
		move.b    9(%a5),%d1				|Type number 2
		movea.l   4(%a5),%a0				|Number 1
		movea.l   12(%a5),%a1				|Number 2
		cmpi.b    #TYPE_INTEGER,%d1
		jbeq      _ExecToken_Affec_integer
		cmpi.b    #TYPE_FLOAT,%d1
		jbeq      _ExecToken_Affec_float
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _ExecToken_Affec_bool
		
		|Affectation chane de caractre*/
		
		rts
		
ExecToken_Affec:
		move.b    8(%a5),%d0				|Oprande number 2
		jbsr      TokensExec_CheckTableVar
		tst.w     %d7
		jbeq      _ExecToken_exit
		cmpi.b    #OPRD_VAR,%d0
		jbeq      _ExecToken_Affec_next
		cmpi.b    #OPRD_VARTABLE,%d0
		jbeq      _ExecToken_Affec_next
		jbra	  _ERROR_incorrect_arg

|============================|
|Tokens d'oprations logiques|
|============================|
ExecToken_Logic_Not:
		rts
		
ExecToken_Logic_And:
		rts
		
ExecToken_Logic_Or:
		rts
		
ExecToken_Logic_Xor:
		rts
		
ExecToken_Logic_Imp:
		rts
		
ExecToken_Logic_Eqv:
		rts
		
ExecToken_Math_Mod:
		rts
		
ExecToken_Math_Divint:
		rts
		
		
|===============================|
|Tokens de ngation mathmatique|
|===============================|
ExecToken_Negatif:
		rts	
		
		.end
			