|=====================
|Fonctions d'execution
|=====================
		.include  "os.h"
		
		.include  "Defines.h"
		.include  "Tbl_Errors.h"
		.include  "GFATEM.h"
		
		|Erreurs
		.xdef     _ERROR_undef_vartable
		.xdef     _ERROR_empty_vartable
		.xdef     _ERROR_types_incompatible
		.xdef     _ERROR_incorrect_arg
		
		|Fonctions
		.xdef     TokensExec_Run
		
		.xdef     TokensExec_AddValue_Float
		.xdef     TokensExec_AddValue_Integer
		.xdef     TokensExec_AddValue_Bool
		
		.xdef     TokensExec_Type_Float_To_Integer
		.xdef     TokensExec_Type_Float_To_Bool
		.xdef     TokensExec_Type_Integer_To_Float
		.xdef     TokensExec_Type_Integer_To_Bool
		.xdef     TokensExec_Type_Bool_To_Float
		.xdef     TokensExec_Type_Bool_To_Integer
		
		.xdef     TokensExec_ConvertType
		.xdef     TokensExec_ConvertOneType
		.xdef     TokensExec_ConvertTwoType
		.xdef     TokensExec_PriorityType
		
		.xdef     TokensExec_AddResult2_Float
		.xdef     TokensExec_AddResult2_Integer
		.xdef     TokensExec_AddResult2_Bool
		
		.xdef     TokensExec_CheckTableVar
		.xdef     TokensExec_CNumArg
		
		
|*************************************************************************
|Gestion des erreurs
|*************************************************************************
_ERROR_undef_vartable:
		move.b    #ERROR_UNDEF_VARTABLE,error_number
		moveq.l   #0,%d7
		rts
		
_ERROR_empty_vartable:
		move.b    #ERROR_EMPTY_VARTABLE,error_number
		moveq.l   #0,%d7
		rts
		
_ERROR_types_incompatible:
		move.b    #ERROR_TYPES_INCOMPATIBLE,error_number
		moveq.l   #0,%d7
		rts

_ERROR_incorrect_arg:
		move.b    #ERROR_INCORRECT_ARG,error_number
		moveq.l   #0,%d7
		rts		
		
|=========================================================================
|TokensExec_Run
|-------------------------------------------------------------------------
|Boucle d'excution des tokens
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: ...
|=========================================================================
TokensExec_Run:
 		move.w    #1,error_line
 		movea.l   ptrEnd_ES(%PC),%a5				|%a5 = Pile ES
 		
_Run_loop: 		
 		tst.b     error_number					|Arrt en cas d'erreur
 		jbne      _Run_EndLoop    				
 		movea.l   TokensFile_DataPtr(%PC),%a0			|Pointeur d'avancement de lecture des donnes
 		cmpa.l    TokensFile_DataMaxAdr(%PC),%a0		|Dpassement donnes
 		jbge      _Run_EndLoop
 		addq.l    #1,TokensFile_DataPtr				|Avance de 1 octet le pointeur de lecture des donnes
 		moveq.l   #0,%d0					|Vide registre
 		move.b    (%a0),%d0					|Lecture TOKEN
 		lsl.w     #2,%d0					|Multiplie par 4
 		lea.l     Tbl_Tokens(%PC),%a0				|Charge la table dans a0
 		move.l    (%a0,%d0.l),%a0
 		jbsr      (%a0) 					|Execute routine
		jbra	  _Run_loop
_Run_EndLoop:		
		rts


|=========================================================================
|TokensExec_AddValue_Float
|-------------------------------------------------------------------------
|Ajoute un flottant
|-------------------------------------------------------------------------
|input:
|  dc.l %d0 - dc.l %d1 - dc.w %d2 = Flottant
|  dc.l %a2 = Zone pile ES
|
|output:
|
|destroy: %a0
|=========================================================================
TokensExec_AddValue_Float:
		movea.l   %a2,%a0					|Permet de ne pas effacer %a2
		move.b    #OPRD_RESULT,(%a0)+				|Change oprande
		move.b    #TYPE_FLOAT,(%a0)+				|Change type
		addq.l    #2,%a0					|Saute les octets d'infos supplmentaires
		move.l    DTO(%PC),(%a0)				|Adresse du rsultat
		movea.l   DTO(%PC),%a0					|Ce place  la zone qui contiendra le rsultat
		move.l    %d0,(%a0)+					|Empile 4 octets dbut flottant
		move.l    %d1,(%a0)+					|Empile 4 octets suivant flottant
		move.w    %d2,(%a0)+					|Empile 2 octets fin flottant
		move.l    %a0,DTO					|Modifie offset DTO
		rts


|=========================================================================
|TokensExec_AddValue_Integer
|-------------------------------------------------------------------------
|Ajoute un entier
|-------------------------------------------------------------------------
|input:
|  dc.l %d0 = Entier
|  dc.l %a2 = Zone pile ES
|
|output:
|
|destroy: %a0
|=========================================================================
TokensExec_AddValue_Integer:
		movea.l   %a2,%a0					|Permet de ne pas effacer %a2
		move.b    #OPRD_RESULT,(%a0)+				|Change oprande
		move.b    #TYPE_INTEGER,(%a0)+				|Change type
		addq.l    #2,%a0					|Saute les octets d'infos supplmentaires
		move.l    DTO(%PC),(%a0)				|Adresse du rsultat
		movea.l   DTO(%PC),%a0					|Ce place  la zone qui contiendra le rsultat
		move.l    %d0,(%a0)+					|Empile entier
		move.l    %a0,DTO					|Modifie offset DTO
		rts


|=========================================================================
|TokensExec_AddValue_Bool
|-------------------------------------------------------------------------
|Ajoute un boolen
|-------------------------------------------------------------------------
|input:
|  dc.b %d0 = Boolean
|  dc.l %a2 = Zone pile ES
|
|output:
|
|destroy: %a2
|=========================================================================
TokensExec_AddValue_Bool:
		movea.l   %a2,%a0					|Permet de ne pas effacer %a2
		move.b    #OPRD_RESULT,(%a0)+				|Change oprande
		move.b    #TYPE_BOOL,(%a0)+				|Change type
		addq.l    #2,%a0					|Saute les octets d'infos supplmentaires
		move.l    DTO(%PC),(%a0)				|Adresse du rsultat
		movea.l   DTO(%PC),%a0					|Ce place  la zone qui contiendra le rsultat
		move.b    %d0,(%a0)+					|Empile entier
		addq.l    #1,%a0					|Ce place  une adresse paire
		move.l    %a0,DTO					|Modifie offset DTO
		rts


|=========================================================================
|TokensExec_Type_Float_To_Integer
|-------------------------------------------------------------------------
|Convertie un flottant en entier
|-------------------------------------------------------------------------
|input:
|  dc.l %d0 - dc.l %d1 - dc.w %d2 = Flottant
|  dc.l %a2 = Zone pile ES
|
|output:
|
|destroy:
|=========================================================================
TokensExec_Type_Float_To_Integer:
		movea.l   4(%a2),%a0					|Va  l'adresse o se trouve le flottant
		move.w    8(%a0),-(%SP)					|Empile fin flottant
		move.l    4(%a0),-(%SP)					|Empile milieu flottant
		move.l    (%a0),-(%SP)					|Empile dbut flottant
		ROM_CALL  trunc
		lea.l     10(%SP),%SP
		jbsr      TokensExec_AddValue_Integer			|Enregistre valeur
		rts
		
	
|=========================================================================
|TokensExec_Type_Float_To_Bool
|-------------------------------------------------------------------------
|Convertie un flottant en boolen
|-------------------------------------------------------------------------
|input:
|  dc.l %d0 - dc.l %d1 - dc.w %d2 = Flottant
|  dc.l %a2 = Zone pile ES
|
|output:
|
|destroy:
|=========================================================================
TokensExec_Type_Float_To_Bool:
		move.w    #0x4000,-(%SP)				|Place flottant = 0 dans SP
		move.l    #0,-(%SP)
		move.l    #0,-(%SP)	
		movea.l   4(%a2),%a0					|Va  l'adresse o se trouve le flottant
		move.w    8(%a0),-(%SP)					|Empile fin flottant
		move.l    4(%a0),-(%SP)					|Empile milieu flottant
		move.l    (%a0),-(%SP)					|Empile dbut flottant
		ROM_CALL  fcmp
		lea.l     20(%SP),%SP
		tst.l     %d0						|Si %d0 diffrent de 0
		sne       %d0						|Remplie %d0 de 1 Flag Z
		jbsr      TokensExec_AddValue_Bool			|Enregistre valeur
		rts
		

|=========================================================================
|TokensExec_Type_Integer_To_Float
|-------------------------------------------------------------------------
|Convertie un entier en flottant
|-------------------------------------------------------------------------
|input:
|  dc.l %d0 = Entier
|  dc.l %a2 = Zone pile ES
|
|output:
|
|destroy:
|=========================================================================
TokensExec_Type_Integer_To_Float:
		movea.l   4(%a2),%a0					|Va  l'adresse o se trouve l'entier
		move.l    (%a0),-(%SP)
		move.w    #flt*4,-(%SP)					|Wrapper
		jbsr      __BC
		addq.l    #6,%SP
		jbsr      TokensExec_AddValue_Float			|Enregistre valeur
		rts
		
		
|=========================================================================
|TokensExec_Type_Integer_To_Bool
|-------------------------------------------------------------------------
|Convertie un entier en boolen
|-------------------------------------------------------------------------
|input:
|  dc.l %d0 = Entier
|  dc.l %a2 = Zone pile ES
|
|output:
|
|destroy:
|=========================================================================
TokensExec_Type_Integer_To_Bool:
		movea.l   4(%a2),%a0					|Va  l'adresse o se trouve l'entier
		tst.l     (%a0)						|Si donnes -1 sinon 0
		sne       %d0
		jbsr      TokensExec_AddValue_Bool			|Enregistre valeur
		rts
			
		
|=========================================================================
|TokensExec_Type_Bool_To_Float
|-------------------------------------------------------------------------
|Convertie un boolen en flottant
|-------------------------------------------------------------------------
|input:
|  dc.b %d0 = Boolen
|  dc.l %a2 = Zone pile ES
|
|output:
|
|destroy:
|=========================================================================
_TokensExec_Type_Bool_To_Float_zero:
		move.l    #0x40000000,%d0				|Flottant = 0.
		jbsr      TokensExec_AddValue_Float			|Enregistre valeur
		rts

TokensExec_Type_Bool_To_Float:
		movea.l   4(%a2),%a0					|Va  l'adresse o se trouve le boolen
		moveq.l   #0,%d1
		move.w    #0,%d2
		tst.b     (%a0)						|Bool = 0?
		jbeq	  _TokensExec_Type_Bool_To_Float_zero 
		move.l    #0xC0001000,%d0				|Flottant = -1.		
		jbsr      TokensExec_AddValue_Float			|Enregistre valeur
		rts
		
		
|=========================================================================
|TokensExec_Type_Bool_To_Integer
|-------------------------------------------------------------------------
|Convertie un boolen en entier
|-------------------------------------------------------------------------
|input:
|  dc.b %d0 = Boolen
|  dc.l %a2 = Zone pile ES
|
|output:
|
|destroy:
|=========================================================================
_TokensExec_Type_Bool_To_Integer_true:
		moveq.l   #-1,%d0
		jbsr      TokensExec_AddValue_Integer			|Enregistre valeur
		rts

TokensExec_Type_Bool_To_Integer:
		movea.l   4(%a2),%a0					|Va  l'adresse o se trouve le boolen
		tst.b     (%a0)						|Bool = 0?	
		jbne      _TokensExec_Type_Bool_To_Integer_true
		moveq.l   #0,%d0
		jbsr      TokensExec_AddValue_Integer			|Enregistre valeur
		rts


|=========================================================================
|TokensExec_ConvertType
|-------------------------------------------------------------------------
|Conversion de type (type src en type dest)
|-------------------------------------------------------------------------
|input:
|  dc.b %d0 = Type source
|  dc.b %d1 = Type destination
|  dc.l %a2 = Zone pile ES
|
|output:
|  dc.l %d7 = Opration russie
|
|destroy: %d2, %a2 conserved
|=========================================================================
_TokensExec_ConvertType_Float_To:
		cmpi.b    #TYPE_INTEGER,%d1
		jbeq      TokensExec_Type_Float_To_Integer
		jbra	  TokensExec_Type_Float_To_Bool

_TokensExec_ConvertType_Integer_To:
		cmpi.b    #TYPE_FLOAT,%d1
		jbeq      TokensExec_Type_Integer_To_Float
		jbra	  TokensExec_Type_Integer_To_Bool
		
_TokensExec_ConvertType_Bool_To:
		cmpi.b    #TYPE_FLOAT,%d1
		jbeq      TokensExec_Type_Bool_To_Float
		jbra	  TokensExec_Type_Bool_To_Integer		
	
TokensExec_ConvertType:
		moveq.l   #-1,%d7					|Prpare fonction comme russie
		
		|Gestion des erreurs
		move.b    (%a2),%d2					|Oprande
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d2			|Tableau indfini
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_EMPTY_VARTABLE,%d2			|Tableau sans indices
		jbeq	  _ERROR_empty_vartable
		
		|Type1=Type2?
		cmp.b     %d0,%d1
		jbeq      _TokensExec_ConvertType_exit
		
		|Types incompatibles?
		move.b    %d0,%d2
		or.b      %d1,%d2 
		cmpi.b    #TYPE_STRING,%d2
		jbeq      _ERROR_types_incompatible 
		
		|Conversion
		cmpi.b    #TYPE_FLOAT,%d0
		jbeq      _TokensExec_ConvertType_Float_To
		cmpi.b    #TYPE_INTEGER,%d0
		jbeq      _TokensExec_ConvertType_Integer_To
		jbra	  _TokensExec_ConvertType_Bool_To
		
_TokensExec_ConvertType_exit:
		rts
		
		
|=========================================================================
|TokensExec_ConvertOneType
|-------------------------------------------------------------------------
|Conversion d'un type suivant des restrictions
|-------------------------------------------------------------------------
|input:
|  dc.b %d0 = Flottant?
|  dc.b %d1 = Entier?
|  dc.b %d2 = Boolean?
|  dc.b %d3 = String?
|  dc.b %d4 = Type optimis
|  dc.l %a2 = Zone pile ES
|
|output:
|  dc.l %d7 = Opration russie
|
|destroy: %a2 conserved
|=========================================================================
_TokensExec_ConvertOneType_convert:
		move.b    %d5,%d0					|Type
		move.b    %d4,%d1					|Type optimis
		jbra      TokensExec_ConvertType

TokensExec_ConvertOneType:
		moveq.l   #-1,%d7					|Prpare fonction comme russie
		
		|Gestion des erreurs
		move.b    (%a2),%d5					|Oprande
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d5			|Tableau indfini
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_EMPTY_VARTABLE,%d5			|Tableau sans indices
		jbeq	  _ERROR_empty_vartable
		
		|Chane de caractre avec autorisation?
		move.b    1(%a2),%d5					|Type
		move.b    %d5,%d6
		and.b     %d3,%d6					|Type & String
		cmpi.b    #TYPE_STRING,%d6				|Type==TYPE_STRING&&String==false
		jbne      _ERROR_types_incompatible
		
		|if ((type==TYPE_FLOAT && fnum==FALSE) || (type==TYPE_INT && integer==FALSE) || (type==TYPE_BOOL && boolean==FALSE))
		not.b     %d0
		and.b     %d5,%d0
		cmpi.b    #TYPE_FLOAT,%d0
		jbeq      _TokensExec_ConvertOneType_convert
		not.b     %d1
		and.b     %d5,%d1
		cmpi.b    #TYPE_INTEGER,%d1
		jbeq      _TokensExec_ConvertOneType_convert
		not.b     %d2
		and.b     %d5,%d2
		cmpi.b    #TYPE_BOOL,%d1
		jbeq      _TokensExec_ConvertOneType_convert
		rts
		

|=========================================================================
|TokensExec_ConvertTwoType
|-------------------------------------------------------------------------
|Conversion pour oprations mathmatiques, concordance des types
|-------------------------------------------------------------------------
|input:
|  dc.b %d0 = Flottant?
|  dc.b %d1 = Entier?
|  dc.b %d2 = Boolean?
|  dc.b %d3 = String?
|  dc.b %d4 = Type optimis
|  dc.l %a2 = Zone pile ES number2
|  dc.l %a3 = Zone pile ES number1
|  dc.b %d7 = Change Ptr?
|
|output:
|  dc.l %d7 = Opration russie
|
|destroy: %a3 conserved
|=========================================================================
_TokensExec_ConvertTwoType_type_string:
		tst.b     %d3						|Autorisation de chanes?
		jbeq      _ERROR_types_incompatible
		eor.b     %d5,%d6					|Si types diffrents
		jbne      _ERROR_types_incompatible
		moveq.l   #-1,%d7					|Opration russie
		rts							|Fin types chanes de caractres

_TokensExec_ConvertTwoType_convert1:
		|Type1=Type2
		move.b    %d5,%d3					|Sauvegarde type number2
		eor.b     %d6,%d3					|Mme type
		jbeq      _TokensExec_ConvertTwoType_exit
		
		jbsr      TokensExec_PriorityType
		and.b     %d3,%d7
		jbne      _TokensExec_ConvertTwoType_next
		move.b    %d6,%d0					|Type number 1
		move.b    %d5,%d1					|Type number 2
		movea.l   %a3,%a2					|ptr 1
		jbra      TokensExec_ConvertType
			
_TokensExec_ConvertTwoType_convert2:
		move.b    %d5,%d0					|Type number 2
		move.b    %d6,%d1					|Type number 1
		jbra      TokensExec_ConvertType
		
TokensExec_ConvertTwoType:
		|Gestion des erreurs
		move.b    (%a2),%d5					|Oprande number2
		move.b    (%a3),%d6					|Oprande number1
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d5
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d6
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_EMPTY_VARTABLE,%d5
		jbeq      _ERROR_empty_vartable
		cmpi.b    #OPRD_EMPTY_VARTABLE,%d6
		jbeq      _ERROR_empty_vartable
		
		|Types incompatibles (chanes de caractres)
		move.b    1(%a2),%d5					|Type number2
		move.b    1(%a3),%d6					|Type number1
		cmpi.b    #TYPE_STRING,%d5
		jbeq      _TokensExec_ConvertTwoType_type_string
		cmpi.b    #TYPE_STRING,%d6
		jbeq      _TokensExec_ConvertTwoType_type_string
		
		|Nombre2 (Autoris) - Nombre1
		|if ((type2==TYPE_FLOAT && fnum) || (type2==TYPE_INT && integer) || (type2==TYPE_BOOL && boolean))
		|Flottant autoris?
		move.b    %d5,%d3
		and.b     %d0,%d3
		cmpi.b    #TYPE_FLOAT,%d3
		jbeq      _TokensExec_ConvertTwoType_convert1
		
		|Entier autoris?
		move.b    %d5,%d3
		and.b     %d1,%d3
		cmpi.b    #TYPE_INTEGER,%d3
		jbeq      _TokensExec_ConvertTwoType_convert1
		
		|Boolen autoris?
		move.b    %d5,%d3
		and.b     %d2,%d3
		cmpi.b    #TYPE_BOOL,%d3
		jbeq      _TokensExec_ConvertTwoType_convert1
		
_TokensExec_ConvertTwoType_next:		
		|Nombre2 (Non autoris) - Nombre1 (Autoris)
		|if ((type1==TYPE_FLOAT && fnum) || (type1==TYPE_INT && integer) || (type1==TYPE_BOOL && boolean))
		|Flottant autoris?
		move.b    %d6,%d3
		and.b     %d0,%d3
		cmpi.b    #TYPE_FLOAT,%d3
		jbeq      _TokensExec_ConvertTwoType_convert2
		
		|Entier autoris?
		move.b    %d6,%d3
		and.b     %d1,%d3
		cmpi.b    #TYPE_INTEGER,%d3
		jbeq      _TokensExec_ConvertTwoType_convert2
		
		|Boolen autoris?
		move.b    %d6,%d3
		and.b     %d2,%d3
		cmpi.b    #TYPE_BOOL,%d3
		jbeq      _TokensExec_ConvertTwoType_convert2
		
		move.b    %d5,%d0						|Type number 2
		move.b    %d4,%d1						|Type optimis
		jbsr	  TokensExec_ConvertType
		
		move.b    %d6,%d0						|Type number 1
		move.b    %d4,%d1						|Type optimis
		movea.l   %a3,%a2						|ptr 1
		jbra	  TokensExec_ConvertType
		
_TokensExec_ConvertTwoType_exit:		
		moveq.l   #-1,%d7
		rts


|=========================================================================
|TokensExec_PriorityType
|-------------------------------------------------------------------------
|Dominant:
|FALSE = Type2
|TRUE = Type1
|-------------------------------------------------------------------------
|input:
|  dc.b %d5 = Type number2
|  dc.b %d6 = Type number1
|
|output:
|  dc.l %d3 = Dominant?
|
|destroy:
|=========================================================================
TokensExec_PriorityType:
		|if ((type1==TYPE_FLOAT) || (type1==TYPE_INT && type2==TYPE_BOOL)) return TRUE;
		|return FALSE;
		
		cmpi.b    #TYPE_FLOAT,%d6
		jbeq      _TokensExec_PriorityType_true
		cmpi.b    #TYPE_INTEGER,%d6
		jbne      _TokensExec_PriorityType_false
		cmpi.b    #TYPE_BOOL,%d5
		jbeq      _TokensExec_PriorityType_true
		
_TokensExec_PriorityType_false:
		moveq.l   #0,%d3
		rts
		
_TokensExec_PriorityType_true:
		moveq.l   #-1,%d3
		rts


|=========================================================================
|TokensExec_AddResult2_xxx (Sans retour possible)
|-------------------------------------------------------------------------
|Ajoute un rsultat aprs un calcul entre 2 nombres
|-------------------------------------------------------------------------
|input:
|  Donnes
|=========================================================================
TokensExec_AddResult2_Float:
		addq.l    #8,%a5
		movea.l   %a5,%a2
		jbra	  TokensExec_AddValue_Float
		
TokensExec_AddResult2_Integer:
		addq.l    #8,%a5
		movea.l   %a5,%a2
		jbra	  TokensExec_AddValue_Integer
		
TokensExec_AddResult2_Bool:
		addq.l    #8,%a5
		movea.l   %a5,%a2
		jbra	  TokensExec_AddValue_Bool
		
		
|=========================================================================
|TokensExec_CheckTableVar
|-------------------------------------------------------------------------
|Gestion erreur pour les tableaux
|-------------------------------------------------------------------------
|input:
|  dc.b %d0 = Operande
|
|output:
|  dc.l %d7 = Opration russie
|
|destroy: 
|=========================================================================
TokensExec_CheckTableVar:
		moveq.l   #-1,%d7						|Prpare fonction comme russie
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbeq      _ERROR_undef_vartable
		cmpi.b    #OPRD_UNDEF_VARTABLE,%d0
		jbeq      _ERROR_undef_vartable
		rts
		
		
|=========================================================================
|TokensExec_CNumArg
|-------------------------------------------------------------------------
|Nombre d'argument tokens de commandes
|-------------------------------------------------------------------------
|input:
|  dc.b %a5 = Point sur le dernier argument
|
|output:
|  dc.l %d6 = Nombre d'argument
|
|destroy: 
|=========================================================================
TokensExec_CNumArg:
		move.l    ptrEnd_ES(%PC),%d6					|Adresse de fin pile ES dans %d0
		sub.l     %a5,%d6						|Adresse %a5 - %d0
		lsr.l     #3,%d6						|Divise par 8 le rsultat
		rts
		
		.end
	