|=============================================================================================
|Constantes
|=============================================================================================  
  .global _comment
  .global GTK_Signature
  .global GTK_Version
  .global GTK_Tokens_Section
  
  .global printf_f
  .global printf_ld
  .global printf_d
  .global printf_s
  .global printf_space
  .global printf_eofline
  
comment:
  .string "GFA_TEM V1.0"
  .even
  
GTK_Signature:
  .ascii  "GFA_GTK"		  |7 octets
  .even
  
GTK_Version:
  .byte	  1
  .even
  
GTK_Tokens_Section:
  .ascii   "TK"			  |2 octets
  .even

printf_f:
  .ascii   "%f\0"
printf_ld:
  .ascii   "%ld\0"
printf_d:
  .ascii   "%d\0"
printf_s:
  .ascii   "%s\0"
printf_space:
  .ascii   " \0"
printf_eofline:
  .ascii   "\12\0"
  .even


|=============================================================================================
|Variables
|=============================================================================================
  .global Start_Variables
  
  |Divers
  .global SaveScreen
  
  |Gestion erreur
  .global error_number
  .global error_line
  
  |Gestion fichier
  .global TokensFile_Name
  .global TokensFile_NameSize
  .global TokensFile_SymEntry
  .global TokensFile_Handle
  .global TokensFile_Data
  .global TokensFile_DataPtr
  .global TokensFile_DataMaxAdr
  .global TokensFile_Size
  .global Buffer_FindFile
  
  |Nombre de variables
  .global nVar_Float
  .global nVar_Int
  .global nVar_Bool
  .global nVar_String
  
  .global nVar_TFloat
  .global nVar_TInt
  .global nVar_TBool
  .global nVar_TString
  
  |Pointeurs allocations
  .global MEM_VARS
  .global MEM_TABS
  
  .global VAR_FLOAT
  .global VAR_INTEGER
  .global VAR_BOOL
  .global VAR_STRING
  
  .global TAB_FLOAT
  .global TAB_INTEGER
  .global TAB_BOOL
  .global TAB_STRING
  .even
  
  |Zone mmoire piles
  .global ptrStart_ES	    	    |Pointeur de donnes de la pile ES (Execution Stack), dbut de la pile
  .global ptrEnd_ES		    |Pointeur de donnes de la pile ES (Execution Stack), fin de la pile	
  .global ptrData_DT		    |Pointeur de donnes de la pile DT (Data Tampon)
  .global DTO			    |Adresse d'criture pour DT	
  
  .global End_Variables
  

|-----------------------
|Dbut section variables
|-----------------------  
Start_Variables:
     
SaveScreen:	       .space 4
  .even
  
error_number:          .space 1
  .even
error_line:	       .space 2
  .even

TokensFile_Name:       .space 18
TokensFile_NameSize:   .space 1
  .even
TokensFile_SymEntry:   .space 4
TokensFile_Handle:     .space 2
TokensFile_Data:       .space 4
TokensFile_DataPtr:    .space 4
TokensFile_DataMaxAdr: .space 4
TokensFile_Size:       .space 2
Buffer_FindFile:       .space 18
  .even

nVar_Float:	       .space 1
nVar_Int:	       .space 1
nVar_Bool:	       .space 1
nVar_String:	       .space 1

nVar_TFloat:	       .space 1
nVar_TInt:	       .space 1
nVar_TBool:	       .space 1
nVar_TString:	       .space 1
  .even

MEM_VARS:	       .space 4
MEM_TABS:	       .space 4

VAR_FLOAT:	       .space 4
VAR_INTEGER:	       .space 4
VAR_BOOL:	       .space 4
VAR_STRING:	       .space 4

TAB_FLOAT:	       .space 4
TAB_INTEGER:	       .space 4
TAB_BOOL:	       .space 4
TAB_STRING:	       .space 4 
  .even 

ptrStart_ES:	       .space 4
ptrEnd_ES:	       .space 4
ptrData_DT:            .space 4
DTO:		       .space 4	
  .even

End_Variables:
  .end
  