| GFA Basic Tokens Execution Manager
|==============================================================================================
| Creation: Samedi 23 Octobre 2004
| Modifications: 
| 23/10/04, 24/10/04, 25/10/04, 27/10/04, 29/10/04, 30/10/04, 31/10/04, 01/11/04, 01/11/04
|==============================================================================================
|----------------------------------------------------------------------------------------------
| Ce programme permet d'excuter un programme crit en GFA Basic contenant des tokens
| d'excution.
| Ligne de commande ;
| Ex: GFATEM ("file")
|
| Auteur: Geoffrey ANNEHEIM
| Dernire modification: Mardi 2 Novembre 2004
|----------------------------------------------------------------------------------------------
	
		.include  "os.h"
		
		.include  "Defines.h"
		.include  "Tbl_Errors.h"
		.include  "GFATEM.h"
		
		.xdef 	  _ti92plus
		.xdef	  _ti89
		.xdef 	  _tigcc_native
		.xdef     __ref_all___startup_code
		.xdef     __ref_all___nostub
		.xdef     __main;_main:
		.xdef     _illegal
		
|Dboguage
_illegal:	illegal
		
|*************************************************************************
|Gestion des erreurs
|*************************************************************************
_ERROR_noargument:
		move.b    #ERROR_NOARGUMENT,error_number
		jbra	  exit_program
		
_ERROR_incorrect_file:
		move.b    #ERROR_INCORRECT_FILE,error_number
		jbra	  exit_program
				
_ERROR_file_no_found:
		move.b    #ERROR_FILE_NO_FOUND,error_number
		jbra	  exit_program
		
_ERROR_incorrect_file_version:
		move.b    #ERROR_INCORRECT_FILE_VERSION,error_number
		jbra	  exit_program
		
_ERROR_tokens_section_no_found:
		move.b    #ERROR_TOKENS_SECTION_NO_FOUND,error_number
		jbra      exit_program
		
_ERROR_no_enough_memory:
		move.b    #ERROR_NO_ENOUGH_MEMORY,error_number
		jbra	  exit_program
		
		
|=========================================================================
|TEM_SaveScreen
|-------------------------------------------------------------------------
|Sauvegarde cran
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: a0
|=========================================================================
TEM_SaveScreen:
		|Allocation mmoire
		move.l    #LCD_SIZE,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		move.l    %a0,%d0
		tst.l     %d0
		jbeq      _ERROR_no_enough_memory
		move.l    %d0,SaveScreen
		
		|Copie cran
		move.l	  #LCD_SIZE,-(%SP)
		move.l    #LCD_MEM,-(%SP)
		move.l    %d0,-(%SP)
		ROM_CALL  memcpy
		lea.l     12(%SP),%SP
		rts

|=========================================================================
|TEM_RestoreScreen
|-------------------------------------------------------------------------
|Restore cran
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: d0, a0
|=========================================================================
TEM_RestoreScreen:
		move.l    SaveScreen(%PC),%d0
		tst.l     %d0
		jbeq      _RestoreScreen_exit
		move.l    #LCD_SIZE,-(%SP)
		move.l    %d0,-(%SP)
		move.l    #LCD_MEM,-(%SP)
		ROM_CALL  memcpy
		addq.l    #4,%SP
		ROM_CALL  free
		addq.l    #8,%SP
_RestoreScreen_exit:
		rts


|=========================================================================
|TEM_Initialize_Variables
|-------------------------------------------------------------------------
|Met  zro toutes les variables
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: d0, a0
|=========================================================================
TEM_Initialize_Variables:
		move.l	  #(End_Variables-Start_Variables),%d0
		lsr.l     #1,%d0
		subq.l    #1,%d0
	        lea.l	  Start_Variables(%PC),%a0
_Initialize_Variables_loop_erase:
		clr.w	  (%a0)+
		dbf	  %d0,_Initialize_Variables_loop_erase
		rts
	

|=========================================================================
|TEM_GetArg_ReadNameFile
|-------------------------------------------------------------------------
|Lecture du nom du fichier  partir de estack
|-------------------------------------------------------------------------
|input:
|
|output:
|  dc.b   TokensFile_NameSize = Taille du nom du fichier.
|  dc.l   TokensFile_Name     = Nom du fichier.
|
|destroy: d0, a4
|=========================================================================				
TEM_GetArg_ReadNameFile:
		|Rcupre le nom du fichier  partir de la pile estack
 		ROM_CALL2 top_estack
 		
 		|Pas d'argument
 		cmpi.b    #0x2D,(%a4)				|Recherche une chaine de caractres STR_TAG
 		jbne      _ERROR_noargument			|Aucun argument spcifi
 		subq.l	  #2,%a4				|Saute caractre NULL on se retrouve  la fin de la chane
 		
 		|Remonte au dbut de la chane 
_GetArg_ReadNameFile_string_loop: 		
 		move.b    (%a4),%d0
 		subq.l    #1,%a4
 		jbne      _GetArg_ReadNameFile_string_loop
 		
 		|Vrification de la taille de la chane entre
 		pea.l     2(%a4)
 		ROM_CALL  strlen
 		addq.l    #4,%SP
 		cmpi.b    #17,%d0				|folder+'\'+file = 17 octets max
 		jbhi      _ERROR_incorrect_file
 		
 		|Copie la chane de caractres
 		move.b    %d0,TokensFile_NameSize
 		subq.l    #4,%SP
 		pea.l     TokensFile_Name(%PC)
 		ROM_CALL  strcpy
 		addq.l    #8,%SP
 		rts 						|Return	
		
		
|=========================================================================
|TEM_GetArg_OpenFile
|-------------------------------------------------------------------------
|Ouvre le fichier et vrifie son header
|-------------------------------------------------------------------------
|input:
|  dc.l   TokensFile_Name
|output:
|
|destroy: d0, d1, a0
|=========================================================================
TEM_GetArg_OpenFile:
		|Pointeur SymEntry
		lea.l     TokensFile_Name(%PC),%a0
		jbsr      FILE_GetSymByName
		move.l    %a0,TokensFile_SymEntry
		tst.l     TokensFile_SymEntry
		jbeq      _ERROR_file_no_found

		|Lock handle
		move.w    12(%a0),-(%SP)
		ROM_CALL  HeapLock
		move.w    %d0,TokensFile_Handle
		
		|Rcupre pointeur et taille du fichier
		ROM_CALL  HeapDeref
		addq.l    #2,%SP
		move.w    (%a0),%d0				|Taille du fichier+2 octets
		subi.w    #GTK_Header_Size+2+6,%d0		|Taille des donnes (Taille fichier-Info_taille-Header-Extension)
		move.w    %d0,TokensFile_Size
		addq.l    #2,%a0
		
		|--------------------------------|		
		|Lecture Header                  |
		|--------------------------------|
		|xxxx  Signature (GFA_GTK)       |     
		|dc.b  Version (1.00)            |
		|                                |
		|dc.b  nVar_Float                |
		|dc.b  nVar_Int                  |
		|dc.b  nVar_Bool                 |
		|dc.b  nVar_String               |
		|                                |
		|dc.b  nVar_TFloat               |
		|dc.b  nVar_TInt                 |
		|dc.b  nVar_TBool                |
		|dc.b  nVar_TString              |
		|                                |
		|dc.w  TK 'Start Execution Tokens|
		|---------------------------------
		
		|Vrification fichier GTK signature
		move.l    #GTK_Signature_Size,-(%SP)
		pea.l     GTK_Signature(%PC)
		pea.l     (%a0)
		ROM_CALL  memcmp
		lea.l     12(%SP),%SP
		tst.w     %d0
		jbne      _ERROR_incorrect_file
		
		|Vrification numro de version
		move.b    (%a0)+,%d0
		cmp.b     GTK_Version(%PC),%d0
		jbne      _ERROR_incorrect_file_version
		
		|Section nombre de variables
		move.l    (%a0)+,nVar_Float			|Variables simples
		move.l    (%a0)+,nVar_TFloat			|Tableaux
		
		|Vrification section TK
		move.l    #GTK_Tokens_Section_Size,-(%SP)
		pea.l     (%a0)
		pea.l     GTK_Tokens_Section(%PC)
		ROM_CALL  memcmp
		addq.l    #4,%SP
		addq.l    #GTK_Tokens_Section_Size,(%SP)	|Saute tmoin dbut section
		move.l    (%SP),TokensFile_Data
		move.l    (%SP),TokensFile_DataPtr		|Adresse avancement de lecture des donnes
		move.w    TokensFile_Size(%PC),%d1		|Adresse de fin des donnes
		andi.l    #0xFFFF,%d1
		add.l     %d1,(%SP)		        
		move.l    (%SP),TokensFile_DataMaxAdr
		addq.l    #8,%SP
		tst.w     %d0					|Vrification memcmp section TK 
		jbne      _ERROR_tokens_section_no_found
		rts
		
		
|=========================================================================
|TEM_GetArg_CloseFile
|-------------------------------------------------------------------------
|Unlock handle
|-------------------------------------------------------------------------
|input:
|  dc.w   TokensFile_Handle
|output:
|
|destroy: d0
|=========================================================================
TEM_GetArg_CloseFile:
		move.w    TokensFile_Handle,%d0    
		tst.w     %d0
		jbeq      _GetArg_CloseFile_no_unlock_handle
		move.w    %d0,-(%SP)
                ROM_CALL  HeapUnlock
                addq.l    #2,%SP
_GetArg_CloseFile_no_unlock_handle:                      
		rts		
		

|=========================================================================
|TEM_Allocate_VarMemory
|-------------------------------------------------------------------------
|Allocation mmoire pour les variables et les tableaux
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: d0, d1, a0
|=========================================================================	
TEM_Allocate_VarMemory:
		clr.l     %d1					|Compte l'espace mmoire  allouer
		
		|---------|
		|VARIABLES|
		|---------|
		|VARS Flottants
		move.b    nVar_Float(%PC),%d1
		mulu.w    #SIZE_FLOAT,%d1
		
		|VARS Integer
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_Int(%PC),%d0
		mulu.w    #SIZE_INTEGER,%d0
		add.w     %d0,%d1
		
		|VARS Bool
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_Bool(%PC),%d0
		
		|Octet d'alignement si ncessaire
		andi.b    #1,%d0
		tst.b     %d0
		jbeq      _Allocate_VarMemory_nVarBool_is_pair
		addq.w    #1,%d0
_Allocate_VarMemory_nVarBool_is_pair:
		add.w     %d0,%d1
		
		|VARS String
		move.w    %d1,-(%SP) 
		clr.w     %d0
		move.b    nVar_String(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		 
		 
		|--------|
		|TABLEAUX|
		|--------|
		|TABS Flottants
		move.w    %d1,-(%SP)
		clr.w	  %d0
		move.b    nVar_TFloat(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		
		|TABS Integer
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_TInt(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		
		|TABS Bool
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_TBool(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		
		|TABS String
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_TString(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		
		|Allocation de l'espace mmoire
		move.l    %d1,%d3					|Sauvegarde d1
		move.l    %d1,-(%SP)
		ROM_CALL  malloc
		
		|Attribution des espaces
		move.l    %a0,MEM_VARS
		move.l    %a0,VAR_FLOAT
		move.l    %a0,%d0
		add.w     16(%SP),%d0
		move.l    %d0,VAR_INTEGER
		move.l    %a0,%d0
		add.w     14(%SP),%d0
		move.l    %d0,VAR_BOOL
		move.l    %a0,%d0
		add.w     12(%SP),%d0
		move.l    %d0,VAR_STRING
		
		move.l    %a0,%d0
		add.w     10(%SP),%d0
		move.l    %d0,MEM_TABS
		move.l    %d0,TAB_FLOAT
		move.l    %a0,%d0
		add.w     8(%SP),%d0
		move.l    %d0,TAB_INTEGER
		move.l    %a0,%d0
		add.w     6(%SP),%d0
		move.l    %d0,TAB_BOOL
		move.l    %a0,%d0
		add.w     4(%SP),%d0
		move.l    %d0,TAB_STRING
		
		|Vide pile SP
		lea.l     7*2+4(%SP),%SP
		
		|Vrification allocation
		move.l    %a0,%d0
		tst.l     %d0
		jbeq	  _ERROR_no_enough_memory
		
		|Initialise zone avec des octets NULL
		move.l    %d3,-(%SP)					|Nombres d'octets
		move.w    #0,-(%SP)					|Caractre NULL
		move.l    %d0,-(%SP)					|Adresse
		ROM_CALL  memset
		lea.l     10(%SP),%SP
		rts


|=========================================================================
|TEM_Unallocate_VarMemory
|-------------------------------------------------------------------------
|Efface allocation mmoire pour les variables et les tableaux
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy:
|=========================================================================
TEM_Unallocate_VarMemory:
		tst.l	  MEM_VARS
		jbeq      _Unallocate_VarMemory_noblock
		move.l	  MEM_VARS(%PC),-(%SP)
		ROM_CALL  free
		addq.l    #4,%SP
_Unallocate_VarMemory_noblock:
		rts		


|=========================================================================
|TEM_Allocate_ES_and_DT
|-------------------------------------------------------------------------
|Allocation mmoire pour la pile ES et le tampon de donnes DT
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: a0
|=========================================================================
TEM_Allocate_ES_and_DT:
		|Allocation pile ES  
		move.l    #ES_SIZE,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		move.l    %a0,%d0
		tst.l     %d0
		jbeq      _ERROR_no_enough_memory
		move.l    %d0,ptrStart_ES
		addi.l    #ES_SIZE,%d0
		move.l    %d0,ptrEnd_ES
		
		|Allocation tampon DT
		move.l    #DT_SIZE,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		move.l    %a0,%d0
		tst.l     %d0
		jbeq      _ERROR_no_enough_memory
		move.l    %d0,ptrData_DT
		move.l    %d0,DTO
		rts
		
		
|=========================================================================
|TEM_Unallocate_ES_and_DT
|-------------------------------------------------------------------------
|Efface allocation mmoire pour la pile ES et le tampon de donnes DT
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy:
|=========================================================================
TEM_Unallocate_ES_and_DT:
		move.l    ptrStart_ES(%PC),%d0
		tst.l     %d0
		jbeq      _Unallocate_ES_and_DT_no_delete_ES
		move.l    %d0,-(%SP)
		ROM_CALL  free
		addq.l    #4,%SP
_Unallocate_ES_and_DT_no_delete_ES:
		move.l    ptrData_DT(%PC),%d0
		tst.l     %d0
		jbeq      _Unallocate_ES_and_DT_no_delete_DT
		move.l    %d0,-(%SP)
		ROM_CALL  free
		addq.l    #4,%sp
_Unallocate_ES_and_DT_no_delete_DT:
		rts


|=========================================================================
|Programme principal
|=========================================================================		
__main:
  		movem.l   %d3-%d7/%a2-%a6,-(%SP) 		|Sauvegarde les registres
 		link.w 	  %a6,#0
 		
 		jbsr      TEM_Initialize_Variables		|Iniailise variables  zro
 		
 		jbsr      TEM_SaveScreen			|Sauvegarde cran
 		
 		jbsr      TEM_GetArg_ReadNameFile		|Lecture de l'argument
 		jbsr	  TEM_GetArg_OpenFile			|Ouvre fichier avec vrification du format
 		
 		jbsr      TEM_Allocate_VarMemory		|Allocation mmoire pour les variables
 		jbsr      TEM_Allocate_ES_and_DT		|Allocation pile ES et tampon DT
 		
 		jbsr      clrscr
 		
 		jbsr      TokensExec_Run			|Boucle d'execution des tokens
 		
 		ROM_CALL  ngetchx 				|Appelle le ROM_CALL ngetchx


exit_program:       
 		jbsr	  TEM_Unallocate_ES_and_DT		|Efface allocation pile ES et tampon DT	
 		jbsr      TEM_Unallocate_VarMemory		|Efface espace mmoires pour les variables
 		
 		jbsr      TEM_GetArg_CloseFile			|Ferme le fichier de tokens
 		
 		ROM_CALL  HeapCompress				|Garbage Collect de la RAM
 		
 		jbsr      TEM_RestoreScreen			|Restaure cran
 		
 		|Affichage erreur
 		clr.l     %d0
 		move.b    error_number,%d0
 		tst.b     %d0
 		jbeq      _main_no_error
 		lea.l     Tbl_Error(%PC),%a0
   		move.l    (%d0,%a0),-(%SP)
   		ROM_CALL  ST_helpMsg
   		addq.l    #4,%SP

_main_no_error: 
 		unlk      %a6
 		movem.l   (%SP)+,%d3-%d7/%a2-%a6 		|Restaure les registres
  		rts
  		
|-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
|FIN DU PROGRAMME
|-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
		.end
		